import os
import json
import jieba
import jieba.analyse
from collections import Counter
from docx import Document

TotalTextCnt = 0
filecnt = 0
KeywordlistArray = []
Doclist = []
Filelist = []
CurrPath = os.getcwd()

# 清除历史信息
for file in os.listdir(CurrPath):
    if file[-4:] == '.txt':
        os.remove(file)

# 获取每篇文章的高频词
for file in os.listdir(CurrPath):
    if file[-5:] == '.docx' and file[0] != '~':
        #print(file)
        # 读取全部文章内容
        CurrDoc = Document(file)
        Doclist.append(CurrDoc)
        Filelist.append(file)
        CurrText = ''
        paranum = 0
        for para in CurrDoc.paragraphs:
            CurrText = CurrText + para.text
            with open(file + '_' + str(paranum) + '.txt', 'w', encoding = 'utf-8') as ParaFile:
                ParaFile.write(para.text)
            paranum = paranum + 1
        TotalTextCnt = TotalTextCnt + len(CurrText)

        # 使用jieba，每篇文章提取前10个高频词
        WordList = jieba.analyse.extract_tags(CurrText, topK=16)
        KeywordlistArray.append(WordList)
        filecnt = filecnt  + 1
# print(KeywordlistArray)
print('文字总量：', TotalTextCnt)

NewKeywordlist = []
# 整合所有高频词到一个字典列表中：剔除重复的关键字
for i in range(filecnt):
    ArrLen = len(KeywordlistArray[i])
    for j in range(ArrLen):
        CurrKey = KeywordlistArray[i][j]
        AlreadyDone = 0
        Newlistlen = len(NewKeywordlist)
        # 检查高频词是否已经处理过
        for k in range(Newlistlen):
            if NewKeywordlist[k] == CurrKey:
                AlreadyDone = 1
                break
        if AlreadyDone == 0:
            NewKeywordlist.append(CurrKey)
# print(NewKeywordlist)

# 给每个高频词建立一个字典，包括：出现的总数，段落索引列表，以及在每个段落出现的次数
WordDictList= []
Listlen = len(NewKeywordlist)
for i in range(Listlen):
    CurrKey = NewKeywordlist[i]
    NewCnt = 0
    UrlDictList = []
    # 重新搜索当前高频词在每个文档每个段落的出现次数，建立url列表
    for j in range(filecnt):
        paranum = 0
        for para in Doclist[j].paragraphs:
            Count = para.text.count(CurrKey)
            if Count > 0:
                MyDict = {}
                MyDict['url'] = Filelist[j] + '_' + str(paranum)
                MyDict['Count'] = Count
                NewCnt = NewCnt + Count
                UrlDictList.append(MyDict)
            paranum = paranum + 1
    # 对url列表进行排序：按出现次数排序
    NewUrlDictList = []
    listlen = len(UrlDictList)
    for m in range(listlen):
        newlistlen = len(UrlDictList)
        Maxnum = 0
        Maxcnt = UrlDictList[0]['Count']
        for n in range(newlistlen - 1):
            if Maxcnt < UrlDictList[n+1]['Count']:
                Maxnum = n + 1
                Maxcnt = UrlDictList[n+1]['Count']
        NewUrlDictList.append(UrlDictList[Maxnum])
        del UrlDictList[Maxnum]
    Mydict1 = {}
    Mydict1[CurrKey] = NewCnt
    Mydict1['urllist'] = NewUrlDictList
    WordDictList.append(Mydict1)

# 最后按照出现次数的总数，对关键字进行排序
NewWordDictList = []
listlen = len(WordDictList)
for i in range(Listlen):
    newlistlen = len(WordDictList)
    Maxnum = 0
    FirstDictKey = list(WordDictList[0].keys())[0]
    Maxcnt = WordDictList[0][FirstDictKey]
    for j in range(newlistlen - 1):
        CurrDictKey = list(WordDictList[j+1].keys())[0]
        if Maxcnt < WordDictList[j+1][CurrDictKey]:
            Maxcnt = WordDictList[j+1][CurrDictKey]
            Maxnum = j + 1
    NewWordDictList.append(WordDictList[Maxnum])
    del WordDictList[Maxnum]

print('关键字数量：', listlen)
# 保存关键字索引到文件
with open('KeyWordDictList.txt', 'w', encoding = 'utf-8') as KeyFile:
    json.dump(NewWordDictList, KeyFile, ensure_ascii=False, indent=4)
